function cle(varargin)
%CLE  Clear all variables from memory EXCEPT the ones you specify
%
%   You may use wildcards (e.g., cle a*) just as with the builtin CLEAR
%   Matching is case sensitive
%
%   Examples
%       cle sam         % clear all variables EXCEPT the 'sam' variable
%       cle x y z       % clear all variables EXCEPT for x, y, and z
%       cle a* b*       % clear all variables EXCEPT those starting with a or b
%       cle('name')     % function form is OK too
 
% Sam Hallman
% shallman@uci.edu
% June 13, 2011

% Note: The builtin CLEAR has some functionality that I didn't bother to
% implement a CLE analogue for. For example, CLEAR supports options such
% as -REGEXP, FUN, FUNCTIONS, GLOBAL, JAVA, and IMPORT, but CLE does not.

if isempty(varargin), return; end

for i = 1:length(varargin)
    varargin{i} = ['^' strrep(varargin{i},'*','.*') '$|'];
end
pattern = cat(2, varargin{:});

ws = evalin('base', 'who');
for i = 1:length(ws)
    s = regexp(ws{i}, pattern, 'once');
    if isempty(s) % no match
        evalin('base', ['clear ' ws{i}]);
    end
end
